
/*

(c) 2011 B.C. Burling eMotimo


    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.



*/


float joy_x_axis; int joy_x_axis_Offset; int joy_x_axis_Bucket; int joy_x_axis_Threshold; int joy_x_axis_map; int speedx;
float joy_y_axis; int joy_y_axis_Offset; int joy_y_axis_Bucket; int joy_y_axis_Threshold; int joy_y_axis_map; int speedy;
float accel_x_axis; int accel_x_axis_Offset; int accel_x_axis_Bucket; int accel_x_axis_Threshold;

int PanStepCount;
int TiltStepCount;

unsigned int joy_lock_count=0;
int i=0;


void calibrate_joystick(int tempx, int tempy)
{
 
    joy_x_axis_Offset=tempx;  joy_x_axis_Threshold=100; //int joy_x_axis_map=180;
    joy_y_axis_Offset=tempy;  joy_y_axis_Threshold=100; //int joy_y_axis_map=180;
    accel_x_axis_Offset=500;  accel_x_axis_Threshold=200; //hardcode this, don't calibrate

    
}

void NunChuckQuerywithEC() //error correction and reinit on disconnect  - takes about 1050 microsecond
{
  do 
    {  
      Nunchuck.getData();
        
        if (Nunchuck.joyx()==0 && Nunchuck.joyy()==0 ) {  //error condition //throw this out and read again
          delay(5);
          NCReadStatus ++;

        }
         else if (Nunchuck.joyx()==255 && Nunchuck.joyy()==255 && Nunchuck.accelx()==1023) {//nunchuck disconnected, then reconnected  - needs initializing
             Nunchuck.init(0);
             NCReadStatus ++;
             

         }
         else if (Nunchuck.accelx()==0 && Nunchuck.accely()==0 && Nunchuck.accelz()==0) {//nunchuck just reintialized - needs a few more reads before good
             delay(1);
             NCReadStatus ++;
             

         }
         else if (Nunchuck.cbutton()==1 && Nunchuck.zbutton()==1) {//both buttons are pressed, throw outde

         }
  
       else NCReadStatus=0;
    }  while (NCReadStatus>0);  
    if(DEBUG_NC) Nunchuck.printData();
    if(DEBUG_NC) Serial.println(micros());
}



void NunChuckjoybuttons()
{


joy_x_axis=constrain((Nunchuck.joyx()-joy_x_axis_Offset),-joy_x_axis_Threshold,joy_x_axis_Threshold);
joy_y_axis=constrain((Nunchuck.joyy()-joy_y_axis_Offset),-joy_y_axis_Threshold,joy_y_axis_Threshold);
accel_x_axis=constrain((Nunchuck.accelx()-accel_x_axis_Offset),-accel_x_axis_Threshold,accel_x_axis_Threshold);


//create a deadband
int deadband = 15; // results in 100-15 or +-85 - this is for the joystick
if (joy_x_axis > deadband)  {
  joy_x_axis=(joy_x_axis-deadband); //this direction lines up with the left right of the display
}
else if (joy_x_axis < -deadband) {
  joy_x_axis=(joy_x_axis+deadband);
}
else {
  joy_x_axis = 0;
}
if (joy_y_axis > deadband)  {
  joy_y_axis=-1*(joy_y_axis-deadband);
}
else if (joy_y_axis < -deadband) {
  joy_y_axis=-1*(joy_y_axis+deadband);
}
else {
  joy_y_axis = 0;
}

int deadband2 = 100; //  this is for the acceleometer
if (accel_x_axis > deadband2)  {
  accel_x_axis=-1*(accel_x_axis-deadband2);
}
else if (accel_x_axis < -deadband2) {
  accel_x_axis=-1*(accel_x_axis+deadband2);
}
else {
  accel_x_axis = 0;
}


//check for joystick lock for more than one second
if (abs(joy_y_axis)>83) {
  joy_lock_count++;
  if (joy_lock_count > 250) joy_lock_count=250; //prevent overflow
}
else {
joy_lock_count=0;
}

c_button=Nunchuck.cbutton();
z_button=Nunchuck.zbutton();

//if (c_button==1 || z_button==1) user_input();

}


void applyjoymovebuffer_exponential()  //exponential stuff
{
//scale based on read frequency  base is 500 reads per second  - now 20 reads per second = 25x
joy_x_axis=(joy_x_axis*joy_x_axis*joy_x_axis)/1200L;
joy_y_axis=(joy_y_axis*joy_y_axis*joy_y_axis)/1200L;
accel_x_axis=(accel_x_axis*accel_x_axis*accel_x_axis)/300L;
//joy_x_axis=(joy_x_axis*joy_x_axis)/4;
//joy_y_axis*=25;
//accel_x_axis*=25;

//control max speeds of the axis
//joy_y_axis=map(joy_y_axis,-90,90,-35,35); //reduc 

 //slow down changes to avoid sudden stops and starts
int ss_buffer=100;
int buffer_x;
int buffer_y;
int buffer_z;


//if ((joy_x_axis-prev_joy_x_reading)>ss_buffer) joy_x_axis=(prev_joy_x_reading+ss_buffer);
//else if ((joy_x_axis-prev_joy_x_reading)<-ss_buffer) joy_x_axis=(prev_joy_x_reading-ss_buffer);

buffer_x=(joy_x_axis-prev_joy_x_reading)/5;
joy_x_axis=prev_joy_x_reading+buffer_x;
if (abs(joy_x_axis)<5) joy_x_axis=0;

//if ((joy_y_axis-prev_joy_y_reading)>ss_buffer) joy_y_axis=(prev_joy_y_reading+ss_buffer);
//else if ((joy_y_axis-prev_joy_y_reading)<-ss_buffer) joy_y_axis=(prev_joy_y_reading-ss_buffer);

buffer_y=(joy_y_axis-prev_joy_y_reading)/5;
joy_y_axis=prev_joy_y_reading+buffer_y;
if (abs(joy_y_axis)<5) joy_y_axis=0;

//if ((accel_x_axis-prev_accel_x_reading)>ss_buffer) accel_x_axis=(prev_accel_x_reading+ss_buffer);
//else if ((accel_x_axis-prev_accel_x_reading)<-ss_buffer) accel_x_axis=(prev_accel_x_reading-ss_buffer);

buffer_z=(accel_x_axis-prev_accel_x_reading)/2;
accel_x_axis=prev_accel_x_reading+buffer_z;
if (abs(accel_x_axis)<5) accel_x_axis=0;

//Serial.print(joy_x_axis);Serial.print(" ___ ");Serial.println(joy_y_axis);


prev_joy_x_reading=joy_x_axis;
prev_joy_y_reading=joy_y_axis;
prev_accel_x_reading=accel_x_axis;

//FloatPoint fp;
//fp.x = 0.0;
//fp.y = 0.0;
//fp.z = 0.0;

fp.x = joy_x_axis + current_steps.x;
fp.y = joy_y_axis + current_steps.y;
if (AUX_ON) fp.z = accel_x_axis + current_steps.z;

set_target(fp.x,fp.y,fp.z);
feedrate_micros=calculate_feedrate_delay_2();
}



void applyjoymovebuffer_linear()
{

//control max speeds of the axis
joy_y_axis=map(joy_y_axis,-90,90,-35,35); //

 //slow down changes to avoid sudden stops and starts

int ss_buffer=1;


if ((joy_x_axis-prev_joy_x_reading)>ss_buffer) joy_x_axis=(prev_joy_x_reading+ss_buffer);
else if ((joy_x_axis-prev_joy_x_reading)<-ss_buffer) joy_x_axis=(prev_joy_x_reading-ss_buffer);

if ((joy_y_axis-prev_joy_y_reading)>ss_buffer) joy_y_axis=(prev_joy_y_reading+ss_buffer);
else if ((joy_y_axis-prev_joy_y_reading)<-ss_buffer) joy_y_axis=(prev_joy_y_reading-ss_buffer);

if ((accel_x_axis-prev_accel_x_reading)>ss_buffer) accel_x_axis=(prev_accel_x_reading+ss_buffer);
else if ((accel_x_axis-prev_accel_x_reading)<-ss_buffer) accel_x_axis=(prev_accel_x_reading-ss_buffer);

//Serial.print(joy_x_axis);Serial.print(" ___ ");Serial.println(joy_y_axis);


prev_joy_x_reading=joy_x_axis;
prev_joy_y_reading=joy_y_axis;
prev_accel_x_reading=accel_x_axis;

FloatPoint fp;
fp.x = 0.0;
fp.y = 0.0;

fp.x = joy_x_axis + current_steps.x;
fp.y = joy_y_axis + current_steps.y;
fp.z = accel_x_axis + current_steps.z;

set_target(fp.x,fp.y,fp.z);
feedrate_micros=calculate_feedrate_delay_2();

}


void nc_sleep()  
{
        if ((joy_x_axis > 15) | (joy_x_axis < -15) | (joy_y_axis > 15) | (joy_y_axis < -15)) {
           digitalWrite(MOTOR_EN, LOW);
            }
        else  digitalWrite(MOTOR_EN, HIGH);
        
}

void applyjoymovebuffer2()  //call new motor routine
{


    //Set long targets
    long maxlong = 2147483647;
    long minlong = -2147483647;
    

          
              
           if(prev_joy_x_reading!=joy_x_axis)
           {
             
             if (joy_x_axis==0) 
                {
                  stopMotor(0);
                }
              else if (joy_x_axis>0) 
                {
                  setPulsesPerSecond(0, abs(joy_x_axis)*150); 
                  //setupMotorMove(0, maxlong);
                }
              else if (joy_x_axis<0)
                {
                  setPulsesPerSecond(0, abs(joy_x_axis)*150);
                  //setupMotorMove(0, minlong);
                }
           }  
           
           if(prev_joy_y_reading!=joy_y_axis)
           { 
              if (joy_y_axis==0) 
                {
                  stopMotor(1);
                }
              else if(joy_y_axis>0) 
                {
                  setPulsesPerSecond(1, abs(joy_y_axis)*100);
                  setupMotorMove(1, maxlong);
                }
              else if(joy_y_axis<0)
                {
                  setPulsesPerSecond(1, abs(joy_y_axis)*100);
                  setupMotorMove(1, minlong);
                }
           }  
           if (prev_accel_x_reading!=accel_x_axis)
           {     
              if (accel_x_axis==0) 
                {
                  stopMotor(2);
                }
              else if (accel_x_axis>0) 
                {
                  setPulsesPerSecond(2, abs(accel_x_axis)*200);
                  setupMotorMove(2, maxlong);
                }
              else if (accel_x_axis<0) 
                {
                  setPulsesPerSecond(2, abs(accel_x_axis)*200);
                  setupMotorMove(2, minlong);
                }
           }

     prev_joy_x_reading=joy_x_axis;
     prev_joy_y_reading=joy_y_axis;
     prev_accel_x_reading=accel_x_axis;
     
 //push to the limits   
      //setupMotorMove(0, joy_x_axis*100);
      //setupMotorMove(1, joy_y_axis*100);
      //setupMotorMove(2, accel_x_axis + current_steps.z);
//void setPulsesPerSecond(int motorIndex, uint16_t pulsesPerSecond)

}
