/*

(c) 2013 B.C. Burling eMotimo


    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.



*/
/* 

 =========================================
PT_LCD_Buttons - Code for Menus and User Interface
 =========================================
 
*/

void Choose_Program()
{
     int yUpDown=0;
     //int displayvar=0;   
         
         if (first_time==1){
            lcd.empty();  
            if (progtype==REG2POINTMOVE) {
                draw(setup_str,66,1,1);   //lcd.at(1,1,"New   Point Move");
                lcd.at(1,5,"2");
            }
            else if (progtype==REV2POINTMOVE) lcd.at(1,1,"Rev 2 Point Move");
            else if (progtype==REG3POINTMOVE) 
            {
                draw(setup_str,66,1,1);   //lcd.at(1,1,"New   Point Move");
                lcd.at(1,5,"3");
            }
            else if (progtype==REV3POINTMOVE) lcd.at(1,1,"Rev 3 Point Move");
            else if (progtype==DFSLAVE) lcd.at(1,2,"DF Slave Mode");
            else if (progtype==SETUPMENU) lcd.at(1,4,"Setup Menu");
            else if (progtype==PANOGIGA) lcd.at(1,5,"Panorama");
            else lcd.at(1,2,"error");
            draw(setup_str,65,2,1);//lcd.at(2,1,"UpDown  C-Select");
            first_time=0;
            NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step
            if (Powersave_PT>2)   disable_PT(); 
            if (Powersave_AUX>2)   disable_AUX();  
            //delay(prompt_time);
            
          }
        
        if ((millis()-NClastread)>50) {
            NClastread=millis();
            //Serial.print("Read");Serial.println(NClastread);
            NunChuckQuerywithEC();
            NunChuckjoybuttons();
        }

        yUpDown=joy_capture_y1(); 
        
        if (yUpDown==1) { //  down
            progtype++;
            if (progtype>6) {
              progtype=6;
            }
            else  { 
              first_time=1;
              delay(250);
            }

        } 
        else if (yUpDown==-1) { //up
            progtype--;
            if (progtype<0) {
              progtype=0;
            }
            else  { 
              first_time=1;
              delay(250);
            }
        }

        button_actions_choose_program(); 
        delay(1);
}



void button_actions_choose_program()
{
      switch (c_button) 
      {

              case 1: // c on - use stored values
                          lcd.empty();
                          lcd.empty();
                          if (progtype==REG2POINTMOVE) {   //new 2 point move
                              REVERSE_PROG_ORDER=false;
                              reset_prog=1;
                              set_defaults_in_ram(); //put all basic paramters in RAM
                              lcd.empty();
                              draw(setup_str,6,1,3);//lcd.at(1,3,"Params Reset");
                              delay(prompt_time);
                              lcd.empty();
                              progstep_goto(1);


                          }
                          else if (progtype==REG3POINTMOVE) {   //new 3 point move
                             REVERSE_PROG_ORDER=false;
                             reset_prog=1;
                             set_defaults_in_ram(); //put all basic paramters in RAM
                             lcd.empty();
                             draw(setup_str,6,1,3);//lcd.at(1,3,"Params Reset");
                             delay(prompt_time);
                             lcd.empty();
                             progstep_goto(101); //three point move
                          }
                           
                          else if  (progtype==DFSLAVE) {  //DFMode
                              lcd.empty();
                              if (PINOUT_VERSION == 4)  lcd.at(1,1,"eMotimo TB3Black");
                              if (PINOUT_VERSION == 3)  lcd.at(1,1,"eMotimoTB3Orange");
                              lcd.at(2,1,"Dragonframe 1.26");
                              DFSetup();
                              DFloop();
                          }
                          else if (progtype==SETUPMENU) {   //setup menu
                             progstep_goto(901);
                          }
                         
                          else if (progtype==REV2POINTMOVE) {   //reverse beta 2Pt
                              REVERSE_PROG_ORDER=true;
                              reset_prog=1;
                              set_defaults_in_ram(); //put all basic paramters in RAM
                              lcd.empty();
                              draw(setup_str,6,1,3);//lcd.at(1,3,"Params Reset");
                              delay(prompt_time);
                              lcd.empty();
                              progstep_goto(1);
                          }
                          else if (progtype==REV3POINTMOVE) {   //new 3 point move reverse
                             REVERSE_PROG_ORDER=true;
                             reset_prog=1;
                             set_defaults_in_ram(); //put all basic paramters in RAM
                             lcd.empty();
                             draw(setup_str,6,1,3);//lcd.at(1,3,"Params Reset");
                             delay(prompt_time);
                             lcd.empty();
                             progstep_goto(101); //three point move
                          }
                          else if (progtype==PANOGIGA) {   //Pano Beta
                              REVERSE_PROG_ORDER=false;
                              intval=5;//default this for static time selection
                              progstep_goto(201);
                          }
                          
                          

                          break;
              case 0:
                switch (z_button) // do nothing
                {
                  case 1: // z button on - 
                      //progtype=0;
                      //progstep_goto(0);
                      delay(1);
                      break;
  
                }
              default:
                  break;   

      }
  
}


//Move to Start Point
void Move_to_Startpoint()
{
        if (first_time==1){
            lcd.empty();  
            lcd.bright(6);
            if (!REVERSE_PROG_ORDER) //normal programing, start first
            {
              draw(setup_str,8,1,1);//lcd.at(1,1,"Move to Start Pt");
              draw(setup_str,14,2,6);//lcd.at(2,6,"C-Next");
            }
            if (REVERSE_PROG_ORDER)
            {
              draw(setup_str,15,1,1);//lcd.at(1,1,"Move to End Pt.");
              draw(setup_str,3,2,1);//lcd.at(2,1,CZ1);
            }

            first_time=0;
            NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step
            delay(prompt_time);
            prev_joy_x_reading=0; //prevents buffer from moving axis from previous input 
            prev_joy_y_reading=0; 
          }


        if ((millis()-NClastread)>NCReadMillis) {
            NClastread=millis();
            //Serial.print("Read");Serial.println(NClastread);
            NunChuckQuerywithEC();
            NunChuckjoybuttons();
            applyjoymovebuffer_exponential();
            dda_move(feedrate_micros);
            button_actions_move_start();  //read buttons, look for home set on c
            delayMicroseconds(200);
        }

}

void button_actions_move_start()
{
             switch (c_button) 
            {

              case 1: // c on 
                          //user_input();
                          lcd.empty();
                          set_position(0.0, 0.0, 0.0); //for new motor commands - setting home
                          if (!REVERSE_PROG_ORDER) draw(setup_str,9,1,3);//lcd.at(1,3,"Start Pt. Set");
                          if (REVERSE_PROG_ORDER) draw(setup_str,16,1,3);//lcd.at(1,3,"End Point Set");
                          delay(prompt_time);
                          lcd.empty();
                          progstep_forward();
                          break;

              case 0:
                switch (z_button) // do nothing
                {
                  case 1: // z button on - 
                      progtype=0;
                      progstep_goto(0);
                      delay(1);
                      break;
  
                }
              default:
                  break;   


            }
  
}  

void Move_to_Endpoint()
{
        if (first_time==1){
            prev_joy_x_reading=0; //prevents buffer from moving axis from previous input 
            prev_joy_y_reading=0; 
          
            if( reset_prog==0 ) {
              lcd.empty();
              draw(setup_str,11,1,1);//lcd.at(1,1,"Moving to stored");
              draw(setup_str,12,2,4);//lcd.at(2,4,"end point");
                
      
              FloatPoint fp;
                fp.x = motor_steps_pt[2][0];
                fp.y = motor_steps_pt[2][1];
                if (AUX_ON) fp.z = motor_steps_pt[2][2];
                else fp.z = 0.0;
             
              set_target(fp.x, fp.y, fp.z); 
	      if (AUX_ON) dda_move(10); //send the motors home   
              else dda_move(30);
            
              lcd.empty();
              draw(setup_str,13,1,1);//lcd.at(1,1,"Confirm or Move");
              draw(setup_str,3,2,1);//lcd.at(2,1,CZ1);
              first_time=0;
              delay(prompt_time);
              NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step

            }
            else { //routine for just moving to end point if nothing was stored.
              lcd.empty();

            if (!REVERSE_PROG_ORDER) //mormal programming, end point last
            {
              draw(setup_str,15,1,1);//lcd.at(1,1,"Move to End Pt.");
              draw(setup_str,3,2,1);//lcd.at(2,1,CZ1);
            }
           
            if (REVERSE_PROG_ORDER) //reverse programing, start last
            {
              draw(setup_str,8,1,1);//lcd.at(1,1,"Move to Start Pt");
              draw(setup_str,14,2,6);//lcd.at(2,6,"C-Next");
            }

              first_time=0;
              delay(prompt_time);
              NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step
              enable_PT(); 
              if (AUX_ON) enable_AUX();  //
            }
          }
        
        NunChuckQuerywithEC();
        NunChuckjoybuttons();
        applyjoymovebuffer_exponential();
        dda_move(feedrate_micros);
        button_actions_move_end();  //read buttons, look for home set on c
        delayMicroseconds(200);
        //delay(1);
}

void button_actions_move_end()
{
  
            switch (c_button) {

              case 1: // con
                  switch (z_button) {
                  case 1: //con zon
                      break;
                      
                  case 0: //con zoff
                       //user_input();
                                              
                      //calculate_deltas();                       

                      motor_steps_pt[2][0] = current_steps.x; //now signed storage
                      motor_steps_pt[2][1] = current_steps.y;
                      motor_steps_pt[2][2] = current_steps.z;
                      
                      if (DEBUG_MOTOR) {Serial.println("motor_steps_end");Serial.print(motor_steps_pt[2][0]);Serial.print(",");Serial.print(motor_steps_pt[2][1]);Serial.print(",");Serial.print(motor_steps_pt[2][2]);Serial.println();}                    
                                            
                      lcd.empty();
                      
                      if (!REVERSE_PROG_ORDER) draw(setup_str,16,1,3);//lcd.at(1,3,"End Point Set");
                      if (REVERSE_PROG_ORDER) draw(setup_str,9,1,3);//lcd.at(1,3,"Start Pt. Set");
                          
                      delay(prompt_time);
                      progstep_forward();
                      break;
                                           
                      }
             case 0: //coff
                  switch (z_button) {
                  case 1: //coff zon
                     //add new double check routine for spurious reads of z
                     //user_input();
                     delay(1);
                     NunChuckQuerywithEC();
                     NunChuckjoybuttons();
                     if (Nunchuck.zbutton()==1){
                       progstep_backward();
                     } 
                     else break;
                  case 0:  //coff zoff
                      break;
                  }
                  break;
                 default:
                      break;
            }
  
}  



void Move_to_Point_X(int Point)
{
        if (first_time==1){
            prev_joy_x_reading=0; //prevents buffer from moving axis from previous input 
            prev_joy_y_reading=0; 
            
            lcd.empty();
            draw(setup_str,10,1,1);//lcd.at(1,1,"Move to Point");
            if (!REVERSE_PROG_ORDER)  { //normal programming
                
                lcd.at(1,15,(Point+1));
            }
            else  { //reverse programming
                
                if (Point==0) lcd.at(1,15,"3");
                else if (Point==1) lcd.at(1,15,"2");
                else if (Point==2) lcd.at(1,15,"1");
            }
            
            if (Point==0) draw(setup_str,14,2,6);//lcd.at(2,6,"C-Next");
            else draw(setup_str,3,2,1);//lcd.at(2,1,CZ1);
            first_time=0;
            delay(prompt_time);
            NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step
            enable_PT(); 
            if (AUX_ON) enable_AUX();  //
        }
        
        NunChuckQuerywithEC();
        NunChuckjoybuttons();
        applyjoymovebuffer_exponential();
        dda_move(feedrate_micros);
        button_actions_move_x(Point);  //read buttons, look for home set on c
        delayMicroseconds(200);
        //delay(1);
}

void button_actions_move_x(int Point)
{
  
            switch (c_button) {

              case 1: // con
                  switch (z_button) {
                  case 1: //con zon
                      break;
                      
                  case 0: //con zoff
                       //user_input();
                                              
                      //calculate_deltas(); 

                      if (Point==0) set_position(0.0, 0.0, 0.0);       //reset for home position               

                      motor_steps_pt[Point][0] = current_steps.x; //now signed storage
                      motor_steps_pt[Point][1] = current_steps.y;
                      motor_steps_pt[Point][2] = current_steps.z;
                      if (DEBUG_MOTOR) {Serial.print("motor_steps_point "); Serial.print(Point); Serial.print(";"); Serial.print(motor_steps_pt[Point][0]);Serial.print(",");Serial.print(motor_steps_pt[Point][1]);Serial.print(",");Serial.print(motor_steps_pt[Point][2]);Serial.println();}                    
                      
                      lcd.empty();
                      draw(setup_str,63,1,3);//lcd.at(1,3,"Point X Set";);
                      if (!REVERSE_PROG_ORDER)  lcd.at(1,9,(Point+1)); //Normal
                      else //reverse programming
                      {
                          if (Point==0) lcd.at(1,9,"3");
                          else if (Point==1) lcd.at(1,9,"2");
                          else if (Point==2) lcd.at(1,9,"1");
                      }
                      
                      if (progstep==201) 
                        {
                          lcd.empty(); 
                          lcd.at (1,5,"AOV Set");
                        }
                      if (progstep==204) //pano - calculate other values
                        {
                          calc_pano_move();
                        }
                      
                      
                      
                      delay(prompt_time);
                      progstep_forward();
                      break;
                                           
                      }
             case 0: //coff
                  switch (z_button) {
                  case 1: //coff zon
                      //add new double check routine for spurious reads of z
                     //user_input();
                     delay(1);
                     NunChuckQuerywithEC();
                     NunChuckjoybuttons();
                     if (Nunchuck.zbutton()==1){
                       progstep_backward();
                     } 
                     else break;
                  case 0:  //coff zoff
                      break;
                  }
                  break;
                 default:
                      break;
            }
  
}  






//Set Camera Interval
void Set_Cam_Interval()
{
        if (first_time==1){
            lcd.empty();
            draw(setup_str,17,1,1);//lcd.at(1,1,"Set Sht Interval");
            delay(prompt_time);
            NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step
            lcd.empty();
            draw(setup_str,18,1,1);//lcd.at(1,1,"Intval:   .  sec");
            draw(setup_str,3,2,1);//lcd.at(2,1,CZ1);
            DisplayInterval();
            first_time=0;
          }
          
          unsigned int intval_last=intval;
          NunChuckQuerywithEC();
          NunChuckjoybuttons();
          if (intval<20) joy_lock_count=0;
          intval += joy_capture3(); 
          intval=constrain(intval,2,6000); //remove the option for Ext Trigger right now
          if (intval_last!=intval) {
                DisplayInterval();
          }
           
            
          button_actions_intval(intval);  //read buttons, look for c button press to set interval
          delay (70);
          //delay (prompt_delay);
          
}

void DisplayInterval() {

                if (intval==EXTTRIG_INTVAL) //run the Ext
                {
                  draw(setup_str,19,1,8);//lcd.at(1,8," Ext.Trig");  
                }
                else if (intval==VIDEO_INTVAL) //run the video routine
                  {
                    draw(setup_str,20,1,8);//lcd.at(1,8," Video   ");  
                  }
                else if (intval<10)
                  {
                    lcd.at(1,13," sec");
                    lcd.at(1,8,"  0.");  
                    lcd.at(1,10,intval/10);  
                    lcd.at(1,12,intval%10);
                  }
                else if (intval<100)
                  {
                    lcd.at(1,8,"  ");  
                    lcd.at(1,10,intval/10);  
                    lcd.at(1,12,intval%10);
                  }
                 else if (intval<1000) 
                  {
                    lcd.at(1,8," ");
                    lcd.at(1,9,intval/10);  
                    lcd.at(1,12,intval%10); 
                  }
                 else 
                  {
                    lcd.at(1,8,intval/10);  
                    lcd.at(1,12,intval%10); 
                  }

}


void button_actions_intval(unsigned int intval)  {
//Serial.print ("entered action3 loop \r\n");
            switch (c_button) // looking for c button press to set interval
            {
              case 1: // con
                   //user_input();
                   interval = (long)intval*100; //tenths of a second to ms
                   //camera_exp_tm=100; 
                       if (intval==EXTTRIG_INTVAL) //means ext trigger
                         {
                             interval=6000;  //Hardcode this to 6.0 seconds are 10 shots per minute to allow for max shot selection
                         }
                        else if (intval==VIDEO_INTVAL) //means video, set very small exposure time
                        {
                             camera_exp_tm=5; //doesn't matter, we never call the shutter
                             interval=video_sample_ms;  //we overwrite this later based on move length
                        }


                   lcd.empty();
                               
                   draw(setup_str,21,1,3);//lcd.at(1,3,"Interval Set"); // try this to push correct character
                   delay(prompt_time);
                   lcd.empty();
                   progstep_forward();
                   break;
    
              case 0:
                  switch (z_button) //this would send us back to step 1
                {
                  case 1: // z button on
                       //user_input();
                       progstep_backward();
                       break;
        
                  default:
                      break;    
                }
              default:
                  break;    
            }    

}


void Set_Duration() //This is really setting frames
{
           if (first_time==1){
             lcd.empty();     
             //          1234567890123456
             draw(setup_str,32,1,5);//lcd.at(1,5,    "Set Move");
             draw(setup_str,33,2,5);//lcd.at(2,5,    "Duration");
             delay(prompt_time*1.5);
             NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step
             lcd.empty();
             draw(setup_str,34,1,10);//lcd.at(1,9,"H:MM:SS");
             if ((intval>3) || (intval==EXTTRIG_INTVAL)) {
               lcd.at(2,11,"Frames"); //SMS
               camera_total_shots=camera_moving_shots; 
               Display_Duration();
             }
             else {
               draw(setup_str,3,2,1);//lcd.at(2,1,CZ1); //Video
               calc_time_remain_dur_sec ();
               display_time(1,1);
             }
             camera_total_shots=camera_moving_shots; 
             //Display_Duration();
             first_time=0;
           }
          
          
          NunChuckQuerywithEC();
          NunChuckjoybuttons();
      
          
          if (intval==VIDEO_INTVAL) { //video
              
              unsigned int overaldur_last=overaldur;
              if (overaldur < 11) overaldur += joy_capture3();
              else overaldur += joy_capture3();
              //constrain(overaldur,2,10000);
              if (overaldur<=0) {overaldur=10000;}
              if (overaldur>10000) {overaldur=1;}
              if (overaldur_last!=overaldur) {
                  calc_time_remain_dur_sec ();
                  display_time(1,1);
              }
          }
          else { //sms
              
              unsigned int camera_moving_shots_last=camera_moving_shots;
              if (camera_moving_shots < 11) camera_moving_shots += joy_capture3();
              else camera_moving_shots += joy_capture3();
              if (camera_moving_shots<=9) {camera_moving_shots=10000;}
              if (camera_moving_shots>10000) {camera_moving_shots=10;}
              //camera_moving_shots=constrain(camera_moving_shots,10,10000);
              camera_total_shots=camera_moving_shots; //we add in lead in lead out later
              if (camera_moving_shots_last!=camera_moving_shots) {
                  Display_Duration();
             
              } //end update time and shots
          } //end sms
          
         

          
          button_actions_overaldur();  //read buttons, look for c button press to set overall time 
          delay (prompt_delay);
}

void Display_Duration() {
      calc_time_remain();
      display_time(1,1);

      if ((intval>3) || (intval==EXTTRIG_INTVAL)) {  
        if (camera_total_shots<100)
          {
            lcd.at(2,7,camera_total_shots);  
            lcd.at(2,4,"   ");
          }
        else if (camera_total_shots<1000)
          {
            lcd.at(2,6,camera_total_shots);  
            lcd.at(2,4,"  ");
          }
        else if (camera_total_shots<10000)
          {
            lcd.at(2,5,camera_total_shots);  
            lcd.at(2,4," ");
          }
        else 
          {
            lcd.at(2,4,camera_total_shots);  
          }
      }


}
  
  


void button_actions_overaldur()  {
//Serial.print ("entered action3 loop \r\n");
            switch (c_button) // looking for c button press 
            {
              case 1: // 
                   //user_input();
                         
                   lcd.empty();
                   draw(setup_str,35,1,3);//lcd.at(1,3,"Duration Set");
                   delay (prompt_time);
                   progstep_forward();
                   break;
   
              case 0:
                  switch (z_button) //this would send us back to step 5
                {
                  case 1: // button on
                       //user_input();
                       progstep_backward();
                       break;
                  default:
                      
                      break;    
                }
              default:
                  
                  break;    
           }    
}






void Set_Static_Time()
{
        if (first_time==1){
            lcd.empty();
            draw(setup_str,22,1,1);//lcd.at(1,1,"Set Static Time");
            delay(prompt_time);
            NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step
            lcd.empty();
            draw(setup_str,23,1,1);//lcd.at(1,1,"Stat_T:   .  sec");
            draw(setup_str,3,2,1);//lcd.at(2,1,CZ1);
            max_shutter=intval-3; //max shutter is .3 seconds less than interval to allow us time to move 
            if (intval==EXTTRIG_INTVAL) max_shutter=600;//external trigger
            if (progtype==PANOGIGA) max_shutter=600; //pano mode
            DisplayStatic_tm();
            first_time=0;
          }
          
          unsigned int static_tm_last=static_tm;
          NunChuckQuerywithEC();
          NunChuckjoybuttons();
          
          if (static_tm<20) joy_lock_count=0;
          static_tm += joy_capture3(); 
          static_tm=constrain(static_tm,1,max_shutter);
          
          if (static_tm_last!=static_tm) {
            DisplayStatic_tm();
          }  
       
          button_actions_stat_time(static_tm);  //read buttons, look for c button press to set interval
          delay (prompt_delay);
}

void DisplayStatic_tm() {
            
                if (intval==VIDEO_INTVAL)
                  {
                    draw(setup_str,24,1,8);//lcd.at(1,8," Video   ");  
                  }
                
                else if (static_tm<10)
                  {
                    lcd.at(1,8,"  0.");  
                    lcd.at(1,10,static_tm/10);  
                    lcd.at(1,12,static_tm%10);
                  }
                 else if (static_tm<100)
                  {
                    lcd.at(1,8,"  ");  
                    lcd.at(1,10,static_tm/10);  
                    lcd.at(1,12,static_tm%10);
                  }
                 else if (static_tm<1000)
                  {
                    lcd.at(1,8," "); 
                    lcd.at(1,9,static_tm/10);  
                    lcd.at(1,12,static_tm%10); 
                  }
                 else
                  {
                    lcd.at(1,8,static_tm/10);  
                    lcd.at(1,12,static_tm%10); 
                  }
}



void button_actions_stat_time(unsigned int exposure)  {
            switch (c_button) // looking for c button press
            {
              case 1: // con
                   //user_input();
                   if (intval!=3)  camera_exp_tm=(long)static_tm*100; //want to get to ms, but this is already multipled by 10 // 3 is used for video mode
                  
                   lcd.empty();
                   
                 
                   draw(setup_str,25,1,1);//lcd.at(1,1,"Static Time Set"); // try this to push correct character
                   delay(prompt_time);
                   lcd.empty();
                   progstep_forward();
                   break;
    
              case 0:
                  switch (z_button) //this would send us back to step 1
                {
                  case 1: // z button on
                       //user_input();
                       progstep_backward();
                       break;
        
                  default:
                      break;    
                }
              default:
                  break;    
            }    

}

void Set_Ramp()
{
        if (first_time==1){
            lcd.empty();
            draw(setup_str,29,1,1);//lcd.at(1,1,"    Set Ramp");
            delay(prompt_time);
            NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step
            lcd.empty();
            draw(setup_str,30,1,1);//lcd.at(1,1,"Ramp:     Frames");
            draw(setup_str,3,2,1);//lcd.at(2,1,CZ1);
            DisplayRamval();
            first_time=0;
        }
            
          unsigned int rampval_last=rampval;
          NunChuckQuerywithEC();
          NunChuckjoybuttons();
          if (rampval<20) joy_lock_count=0;
          rampval += joy_capture3();
          if (rampval<1) {
            rampval=1;
            delay(prompt_time/2);
          }
          //if (rampval>500) {rampval=2;}
          
          if( rampval*3 > camera_moving_shots ) {    // we have an issue where the ramp is to big can be 2/3 of total move, but not more.
              rampval=camera_moving_shots/3; //set to 1/3 up and 1/3 down (2/3) of total move)
              delay(prompt_time/2);
          }     
          
          //rampval=constrain(rampval,1,500); // 
          if (rampval_last!=rampval) {
              DisplayRamval();
          }
          //delay(50);
          button_actions_rampval();  //read buttons, look for c button press to set interval
          delay (prompt_delay);
}    

void DisplayRamval()  {      
  lcd.at(1,7,rampval); 
  if (rampval <10)  lcd.at(1,8,"  ");  //clear extra if goes from 3 to 2 or 2 to  1
  if (rampval<100)  lcd.at(1,9," ");  //clear extra if goes from 3 to 2 or 2 to  1
}

void button_actions_rampval()  {

            switch (c_button) // looking for c button press 
            {
              case 1: // 
                  //user_input();
                  //we actually don't store anything here - wait for final confirmation to seteverything
            
                   lcd.empty();
                   draw(setup_str,31,1,5);//lcd.at(1,5,"Ramp Set");
                   delay(prompt_time);
                   progstep_forward();
                   break;
    
              case 0:
                  switch (z_button) //this would send us back
                {
                  case 1: // button on
                       //user_input();
                       progstep_backward();
                       
                       break;
                  default:
                      break;    
                }
              default:
                  break;    
           }    
}

void Set_LeadIn_LeadOut()
{
    
          if (first_time==1){
             lcd.empty();     
             draw(setup_str,36,1,1);//lcd.at(1,1,"Set Static Lead");
             draw(setup_str,37,2,2);//lcd.at(2,2,"In/Out Frames");
             delay(prompt_time);
             NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step
             lcd.empty();
             draw(setup_str,38,1,6);//lcd.at(1,1,"IN -    Out");
             draw(setup_str,3,2,1);//lcd.at(2,1,CZ1);
             first_time=0;
             lcd.at(1,9,lead_out);
             cursorpos=1;
             DisplayLeadIn_LeadOut();
           }
          
          int joyxysum_last=joy_x_axis+joy_y_axis; //figure out if changing
          
          NunChuckQuerywithEC();
          NunChuckjoybuttons();
          cursorpos += joy_capture_x1();
          cursorpos = constrain(cursorpos,1,2);
          
          if (joyxysum_last!=(joy_x_axis+joy_y_axis)||abs(joy_x_axis+joy_y_axis)>10){ //check to see if there is an input, otherwise don't update display
             DisplayLeadIn_LeadOut();
          }
         
          button_actions_lead_in_out();  //read buttons, look for c button press to ramp
          delay (prompt_delay);
}

void DisplayLeadIn_LeadOut() {
        
    if (cursorpos==2) lcd.pos(1,13);
    
    if (cursorpos==1){ //update lead in

        lcd.cursorOff();
        lead_in += joy_capture3();
        if (lead_in<1) {lead_in=5000;}
        if (lead_in>5000) {lead_in=1;}
        lcd.at(1,1,lead_in);
        
                      
        if (lead_in<10) { lcd.at(1,2,"   ");}
        if (lead_in<100) { lcd.at(1,3,"  ");}
        if (lead_in<1000) { lcd.at(1,4," ");}
        lcd.cursorBlock();
    }
    
    else { //update leadout
                 
        lcd.cursorOff(); 
        lead_out += joy_capture3();
        if (lead_out<1) {lead_out=5000;}
        if (lead_out>5000) {lead_out=1;}
        lcd.at(1,9,lead_out);
        
                     
        if (lead_out<10) { lcd.at(1,10,"   ");}
        if (lead_out<100) { lcd.at(1,11,"  ");}
        if (lead_out<1000) { lcd.at(1,12," ");}
        lcd.cursorBlock();
    }

}

void button_actions_lead_in_out()  {
            switch (c_button) // looking for c button press
            {
              case 1: // 
                   //user_input();
                   lcd.cursorOff();
                   camera_total_shots=camera_moving_shots+lead_in+lead_out;
                   

                   lcd.empty();
           
                   draw(setup_str,39,1,1);//lcd.at(1,1,"Lead Frames Set");
                   
                  
                  if (intval==VIDEO_INTVAL) {
                    //if (intval==VIDEO_INTVAL) camera_moving_shots=(overaldur*1000L)/interval; //figure out moving shots based on duration for video only
                    camera_moving_shots=video_segments; //hardcode this and back into proper interval - this is XXX segments per sequence
                    interval=overaldur*1000L/camera_moving_shots;   //This gives us ms 
                    camera_total_shots=camera_moving_shots+lead_in+lead_out; //good temp variable for display
                  }
                  
                   
                  //fix issues with ramp that is too big 
                  if( rampval*3 > camera_moving_shots ) {    // we have an issue where the ramp is to big can be 2/3 of total move, but not more.
                        rampval=camera_moving_shots/3; //set to 1/3 up and 1/3 down (2/3) of total move)
                  }     
                  
                  
                  //Set keyframe points for program to help with runtime calcs
                    keyframe[0][0]=0; //start frame
                    keyframe[0][1]=lead_in; //beginning of ramp
                    keyframe[0][2]=lead_in+rampval; //end of ramp, beginning of linear
                    keyframe[0][3]=lead_in+camera_moving_shots-rampval;  //end or linear, beginning of rampdown
                    keyframe[0][4]=lead_in+camera_moving_shots; //end of rampdown, beginning of leadout
                    keyframe[0][5]=lead_in+camera_moving_shots+lead_out; //end of leadout, end of program
                  
                    if (DEBUG_MOTOR) {
                        for (int i=0; i < 6; i++){
                            Serial.print("Keyframe");Serial.print(i);Serial.print("_");Serial.println(keyframe[0][i]);
                        }
                    }       

                    go_to_start(); //


                   write_all_ram_to_eeprom(); //set this here to allow us to rerun this program from this point if we just want to turn it on reveiw and go
                   //restore_from_eeprom_memory();
                   if (DEBUG) review_RAM_Contents();
                   
                   //delay(prompt_time);
                   if (Powersave_PT>2)   disable_PT(); 
                   if (Powersave_AUX>2)   disable_AUX();
                   NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step
                   progstep_forward();
                   break;
    
              case 0:
                  switch (z_button) //this would send us back
                {
                  case 1: // button on
                       lcd.cursorOff();
                       //user_input();
                       progstep_backward();
                       break;
                  default:
                      break;    
                }
              default:
                  break;    
           }    
}




void Review_Confirm()
{
              
           if (first_time==1){
             lcd.empty();     
             draw(setup_str,41,1,4);//lcd.at(1,4,"Review and");
             draw(setup_str,42,2,2);//lcd.at(2,2,"Confirm Setting");
             //delay(prompt_time);
             delay(prompt_time);
             NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step
             //delay(100);
             lcd.empty();
             first_time=0;
             diplay_last_tm =millis();
             DisplayReviewProg();
             reviewprog = 2;
           }
          
          if ((millis()-diplay_last_tm) >(prompt_time*2)){ //test for display update
       
              reviewprog ++;
              diplay_last_tm =millis();
              if (reviewprog >4) reviewprog=2;
              DisplayReviewProg();

               
          } //end test for display update
          

          

          NunChuckQuerywithEC();
          NunChuckjoybuttons();
   
          if (abs(joy_y_axis)>20) {  //do read time updates to delay program
            reviewprog=4;
            DisplayReviewProg();
            diplay_last_tm =millis();
          }
          

          
          button_actions_review();
          delay(100);

         
}


void DisplayReviewProg() {

    switch (reviewprog)  {
        case 1:   // 
          lcd.empty();
          draw(setup_str,43,1,1);//lcd.at(1,1,"Pan Steps:");
          draw(setup_str,44,2,1);//lcd.at(2,1,"Tilt Steps:");
          //lcd.at(1,12,motor_steps[0]);
          lcd.at(1,12,(int)linear_steps_per_shot[0]);
          lcd.at(2,12,(int)linear_steps_per_shot[1]);
        break;
        
        case 2:   // 
          lcd.empty();
          draw(setup_str,45,1,1);//lcd.at(1,1,"Cam Shots:");
          draw(setup_str,46,2,1);//lcd.at(2,1,"Time:"); 
          lcd.at(1,12,camera_total_shots);
          calc_time_remain();
          display_time(2,6);
        break;
        
        case 3:   // 
          lcd.empty();
          draw(setup_str,47,1,6);//lcd.at(1,6,"Ready?");
          draw(setup_str,48,2,2);//lcd.at(2,2,"Press C Button");
        break;            
        case 4:   // 
          //lcd.empty();
          lcd.at(1,1,"StartDly:    min");
          lcd.at(2,2,"Press C Button");
          if (start_delay_min<20) joy_lock_count=0;
          start_delay_min += joy_capture3();
          if (start_delay_min<0) {start_delay_min=500;}
          if (start_delay_min>500) {start_delay_min=0;}
          lcd.at(1,11,start_delay_min); 
           // if (start_delay_min <10)  lcd.at(1,8,"  ");  //clear extra if goes from 3 to 2 or 2 to  1
           // if (start_delay_min <100)  lcd.at(1,9," ");  //clear extra if goes from 3 to 2 or 2 to  1
      
          
        break;
  
    }//end switch


}



void button_actions_review()  {
            switch (c_button) // looking for c button press start
            {
              case 1: // 
                   //user_input();
                   lcd.empty();
                   MOVE_REVERSED_FOR_RUN=false; //Reset This
                   if (start_delay_min>0) {
                     lcd.at(1,2,"Delaying Start");
                     delay (start_delay_min*60L*1000L);
                     lcd.empty();
                   }
                   
                   enable_PT(); 
                   if (AUX_ON) enable_AUX();  //

                   draw(setup_str,49,1,1);//lcd.at(1,1,"Program Running");
                   delay(prompt_time/3);
                   
                   if (intval==EXTTRIG_INTVAL)  lcd.at(2,1,"Waiting for Man.");
                 
                   Program_Engaged=true;
                   Interrupt_Fire_Engaged=true; //just to start off first shot immediately
      
                   interval_tm = 0; //set this to 0 to immediately trigger the first shot 
                   
                   if (intval>3) { //SMS Mode
                     lcd.empty(); //clear for non video
                     progstep=50; //  move to the main programcamera_real_fire
                   }
                   else if (intval==VIDEO_INTVAL)  {
                     //lcd.empty(); //leave "program running up for video
                     progstep=51; 
                   }
                   else if (intval==EXTTRIG_INTVAL)  { //manual trigger/ext trigge
                      lcd.empty(); //clear for non video
                      progstep=52; //  move to the external interrup loop
                      ext_shutter_count=0; //set this to avoid any prefire shots or cable insertions.
                      lcd.at(1,1,"Waiting for Trig");
                   }
                   
                   //lcd_backlight_cur= 100;
                   first_time=1;
                   lcd.bright(LCD_BRIGHTNESS_DURING_RUN);
                   break;
    
              case 0:
                  switch (z_button) //this would send us back to step 6
                {
                  case 1: // button on
                       //user_input();
                       progstep_backward();
                       break;
                  default:
                      break;    
                }
              default:
                  break;    
           }    
}

//void DelayStart ()

//{
//  delay(1);
//}


void progstep_forward()
{
first_time=1;
progstep++;
delay(100);
NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step
}

void progstep_backward()
{
first_time=1;
if (progstep>0) progstep--;
else progstep=0;
delay(100);
NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step
}

void progstep_goto(unsigned int prgstp)
{
  lcd.empty();
  first_time=1;
  progstep=prgstp;
  delay(100);
  NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step
}


void button_actions90()  { //repeat - need to turn off the REVERSE_PROG_ORDER flag
            switch (c_button) // looking for c button for Repeat
            {
              case 1: // 
                   // Normal 
                   
                   REVERSE_PROG_ORDER=false;
                   if (Powersave_PT>2)   disable_PT(); 
                   if (Powersave_AUX>2)   disable_AUX();
                   //Program_Engaged=true;
                   camera_fired = 0;   
                   lcd.bright(8);         
                   if (progtype==REG2POINTMOVE||progtype==REV2POINTMOVE) {
                     go_to_start();
                     progstep_goto(8);
                   } 
                   else if (progtype==REG3POINTMOVE||progtype==REV3POINTMOVE){
                     go_to_start();
                     progstep_goto(109);
                   }

                   break;
         
          
           case 0:
                  switch (z_button) // Reverse
                {
                  case 1: // button on
                   REVERSE_PROG_ORDER=true;
                   if (Powersave_PT>2)   disable_PT(); 
                   if (Powersave_AUX>2)   disable_AUX();
                   //Program_Engaged=true;
                   camera_fired = 0;   
                   lcd.bright(8);         
                   if (progtype==REG2POINTMOVE||progtype==REV2POINTMOVE) {
                     go_to_start();
                     progstep_goto(8);
                   } 
                   else if (progtype==REG3POINTMOVE||progtype==REV3POINTMOVE){
                     go_to_start();
                     progstep_goto(109);
                   }
                   
                   break;
                   
                   default:
                      break;    
                }
              default:
                  break;  
                  
            }
}





int joy_capture2() //captures joystick input
{
      prompt_delay=(500-5*abs(joy_y_axis));
      //Serial.print("slow");Serial.println(prompt_delay);
      return -1*constrain(map(joy_y_axis,-20,20,-1,2),-1,1);
 }

int joy_capture3() //captures joystick input and conditions it for UI
{

  if (joy_lock_count>245){ //really really fast
      //Serial.println("reallyreallyfast");
      prompt_delay=0;
      return -1*map(joy_y_axis,-55,55,-40,40);  
    }
  if (joy_lock_count>50){ //really fast
      //Serial.println("reallyfast");
      prompt_delay=10;
      return -1*map(joy_y_axis,-100,100,-10,10);
    }
    else if (joy_lock_count>20){ //pretty fast
      //Serial.println("prettyfast");
      prompt_delay=70;
      return -1*map(joy_y_axis,-80,80,-10,10);
    }
    else if (abs(joy_y_axis)>10){ //go variable add delay which we run later
      prompt_delay=(500-6*abs(joy_y_axis));
      if (prompt_delay<0) prompt_delay=15;
      //Serial.print("slow");Serial.println(prompt_delay);
      return -1*constrain(map(joy_y_axis,-20,20,-1,2),-1,1);
      
    }
    else { //null loop
      //Serial.println("nullloop");
      prompt_delay=0;
      return (0);
    }
}
int joy_capture_x1() //captures joystick input
{
  int returned_val=0;  
  returned_val=map(joy_x_axis,-80,80,-5,6);
  //Serial.print(returned_val);
  if (abs(returned_val)>3) delay(150);
  return returned_val;
}


int joy_capture_y1() //captures joystick input for up down
{
  return map(joy_y_axis,-85,85,-1,1);
}


void display_status()  {
  //1234567890123456
  //1234567890123456
  //XXXX/XXXX LeadIn      LeadOT Rampup RampDn, Pause
  //HH:MM:SS  XX.XXV 
    if (first_time==1){
             lcd.empty();     
             lcd.at(1,5,"/");//Add to one time display update
             lcd.at(2,13,".");
             lcd.at(2,16,"v");
             NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step
             //lcd.empty();
             first_time=0;
     }
//update upper left camera fired/total shots
  unsigned int camera_fired_display=camera_fired+1;
  if (camera_fired_display<10) lcd.at(1,4,camera_fired_display);
  else if (camera_fired_display<100) lcd.at(1,3,camera_fired_display);
  else if (camera_fired_display<1000) lcd.at(1,2,camera_fired_display);
  else lcd.at(1,1,camera_fired_display);

  lcd.at(1,6,camera_total_shots); 
 
//Update program progress secion - upper right  

if (progtype==REG2POINTMOVE||progtype==REV2POINTMOVE) {
      switch (program_progress_2PT) {
            case 1: 
              draw(setup_str,51,1,11);//lcd.at(1,11,"LeadIn"); 
            break;
               
            case 2: 
              draw(setup_str,52,1,11);//lcd.at(1,11,"RampUp");
            break;
            
            case 3: 
              draw(setup_str,53,1,11);//lcd.at(1,11,"Linea");
            break;
            
            case 4:  
              draw(setup_str,54,1,11);//lcd.at(1,11,"RampDn"); 
            break;
            
            case 5:  
              draw(setup_str,55,1,11);//lcd.at(1,11,"LeadOT");
            break;
            
           
            case 9: 
              draw(setup_str,56,1,11);//lcd.at(1,11,"Finish");  
            break;  

            
         }              
}


if (progtype==REG3POINTMOVE||progtype==REV3POINTMOVE) {
       switch (program_progress_3PT) {
                        
            case 101: //3PT Lead In
              draw(setup_str,51,1,11);//lcd.at(1,11,"LeadIn");  
            break; 
            
            case 102: //3PT leg 1
              lcd.at(1,11,"Leg 1 ");  
            break; 
            
            case 103: //3PT leg 2
              lcd.at(1,11,"Leg 2 ");  
            break;
            
            case 105: //3PT Lead Out
              draw(setup_str,55,1,11);//lcd.at(1,11,"LeadOT"); 
            break; 
            
            case 109: //3PT Finish
              draw(setup_str,56,1,11);//lcd.at(1,11,"Finish");
            break;    
              
         }              
}

if (progtype==PANOGIGA) {

              lcd.at(1,11,"Pano ");  
        
}

//Update Run Clock
calc_time_remain();
display_time(2,1);

//Do multiple reads of the battery and average
int batteryread=0;
for (int i=0; i<3; i++){
  batteryread += analogRead(0); // 
 }
  batteryread = batteryread/3;

int batt1= (batteryread/51); //  51 point per volt
int batt2= ((batteryread%51)*100)/51; //3 places off less the full decimal

if (batt1<10){
      lcd.at(2,11,"0");
      lcd.at(2,12,batt1);
    }
else lcd.at(2,11,batt1);

if (batt2<10){
      lcd.at(2,14,"0");
      lcd.at(2,15,batt2);
    }
else lcd.at(2,14,batt2);

  if (POWERDOWN_LV) {
      if (batt1<9) {
          draw(setup_str,7,2,1); //lcd.at(2,1,"Low Power");
          batt_low_cnt++;
          
          if (batt_low_cnt >20) {
            //Stop the program and go to low power state
            disable_PT(); 
            disable_AUX();
            Program_Engaged=false;
            lcd.empty();
            draw(setup_str,60,1,1);//lcd.at(1,1,"Battery too low");
            draw(setup_str,61,2,1);//lcd.at(2,1,"  to continue");
            
          }
          
          first_time=1;
      }  
      else batt_low_cnt=0;
  }//end of powerdown if
}//end of display

void calc_time_remain() {
timeh=((((float)camera_total_shots-(float)camera_fired)*(float)interval)/3600000); //hours
timem=((((float)camera_total_shots-(float)camera_fired)*(float)interval)/60000)-(timeh*60); //minutes  - could use modulus, but more confusing
time_s=((((float)camera_total_shots-(float)camera_fired)*(float)interval)/1000)-(timeh*3600)-(timem*60);; //seconds
}

void calc_time_remain_dur_sec () {
timeh=((float)(overaldur)/3600); //hours
timem=((float)(overaldur)/60)-(timeh*60); //minutes  - could use modulus, but more confusing
time_s=((float)(overaldur)/1)-(timeh*3600)-(timem*60);; //seconds
}

void display_time (int row, int col) {
    lcd.at(row,col+2,":");
    lcd.at(row,col+5,":");  
    
    if (timeh<10){
      lcd.at(row,col," ");
      lcd.at(row,col+1,timeh);
    }
    else lcd.at(row,col,timeh);
    
    if (timem<10){
      lcd.at(row,col+3,"0");
      lcd.at(row,col+4,timem);
    }
    else lcd.at(row,col+3,timem);
    
    if (time_s<10){
      lcd.at(row,col+6,"0");
      lcd.at(row,col+7,time_s);
    }
    else lcd.at(row,col+6,time_s);
}

void load_lcd_buffer(const char *stringval[],int array_num) {
  memset(lcdbuffer1, '0', 16);
  strcpy_P(lcdbuffer1, (char*)pgm_read_word(&(stringval[array_num])));
  //lcd.at(col,row,lcdbuffer1);
  
}

void draw(const char *stringval[],int array_num,int col, int row) {
  memset(lcdbuffer1, '0', 16);
  strcpy_P(lcdbuffer1, (char*)pgm_read_word(&(stringval[array_num])));
  lcd.at(col,row,lcdbuffer1);
  
}

void Check_Prog()  //this is a routine for the button presses in the program
{

            switch (c_button) // looking for c button press 
            {
              case 1: // 
                  switch (z_button) //
                  {
                    case 1: // button on
                         //Interrupt_Fire_Engaged=true;
                         Button_Read_Count++;
                         delay(10);
                         if ((millis()-input_last_tm)>1000000) Button_Read_Count=0;
                         input_last_tm=millis();
                         break;
                    default:
                        
                        break;    
                  }
   
              case 0:
                  switch (z_button) //this would send us back to step 5
                {
                  case 1: // button on

                       break;
                  default:
                      
                      break;    
                }
              default:
                  
                  break;    
           }    
}

void Pause_Prog()    {
      Button_Read_Count=0;
      Program_Engaged=!Program_Engaged; //turn off the loop
      if (!Program_Engaged) {  //program turned off
        write_all_ram_to_eeprom(); //capture current steps too!
        //lcd.empty();
        lcd.at(1,11,"Pause ");
        delay(2000);
        NunChuckQuerywithEC();
      }
      else { //turn it on
        lcd.at(1,11,"Resume");
        delay(500);
        NunChuckQuerywithEC();
      }
}



void Setup_AUX_ON()   {
     int yUpDown=0;
     
     //int displayvar=0;   
         
         if (first_time==1){
            //prompt_val=AUX_ON;
            lcd.empty();  
            draw(setup_str,74,1,1);//lcd.at(1,1,"Aux Motor:");
            if (AUX_ON==0)  lcd.at(1,12,"OFF");
            if (AUX_ON==1)  lcd.at(1,12,"ON");
            draw(setup_str,65,2,1);//lcd.at(2,1,"UpDown  C-Select");
            first_time=0;
            delay(500);
            NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step
            //delay(prompt_time);
            
          }
        
        if ((millis()-NClastread)>50) {
            NClastread=millis();
            NunChuckQuerywithEC();
            NunChuckjoybuttons();
        }

        yUpDown=joy_capture_y1(); 
        
        if (yUpDown==-1) { //  up
            if (AUX_ON==0) {
              AUX_ON=1;
              first_time=1;
              delay(250);
            }
            
        } 
        else if (yUpDown==1) { //down
            if (AUX_ON==1) {
              AUX_ON=0;
              first_time=1;
              delay(250);
            }
            
            
        }
        if (AUX_ON>1) {
              AUX_ON=0;
              first_time=1;
              delay(250);
        }
            
        

        if (c_button || z_button) {
        
            eeprom_write(102, AUX_ON);
            //delay(500);
            progstep_forward();
            
        
        }
}



void Setup_PAUSE_ENABLED()   {
     int yUpDown=0;
     
     //int displayvar=0;   
         
         if (first_time==1){
            lcd.empty();  
            draw(setup_str,62,1,1);//lcd.at(1,1,"Pause ")
            if (PAUSE_ENABLED==0){
                draw(setup_str,68,1,8);//lcd.at(1,7,"Disabled")
            }  
            if (PAUSE_ENABLED==1) {
                draw(setup_str,67,1,8);//lcd.at(1,7,"Enabled")
            } 
            draw(setup_str,65,2,1);//lcd.at(2,1,"UpDown  C-Select");
            first_time=0;
            delay(500);
            NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step
            //delay(prompt_time);
            
          }
        
        if ((millis()-NClastread)>50) {
            NClastread=millis();
            //Serial.print("Read");Serial.println(NClastread);
            NunChuckQuerywithEC();
            NunChuckjoybuttons();
        }

        yUpDown=joy_capture_y1(); 
        
        if (yUpDown==-1) { //  up
            if (PAUSE_ENABLED==0) {
              PAUSE_ENABLED=1;
              first_time=1;
              delay(250);
            }
            
        } 
        else if (yUpDown==1) { //down
            if (PAUSE_ENABLED==1) {
              PAUSE_ENABLED=0;
              first_time=1;
              delay(250);
            }
            
        }
        if (PAUSE_ENABLED>1) { //in case bad values for EEPROM
              PAUSE_ENABLED=0;
              first_time=1;
              delay(250);
        }

        if (c_button) {
        
            eeprom_write(103, PAUSE_ENABLED);
            progtype=0;
            //delay(1000);
            //progstep_forward();
            progstep_forward();
        
        }
        
        if (z_button) {
        
            eeprom_write(103, PAUSE_ENABLED);
            progtype=0;
            //delay(500);
            //progstep_forward();
            progstep_backward();
        }
}

void Setup_Powersave_PT()   {
     int yUpDown=0;
     
     //int displayvar=0;   
         
         if (first_time==1){
            //prompt_val=Powersave_PT;
            lcd.empty(); 
            lcd.at(1,1,"PT Motors on"); 
            if (Powersave_PT==1)      draw(setup_str,70,2,1); //lcd.at(2,1,"Always");
            if (Powersave_PT==2)      draw(setup_str,71,2,1); //lcd.at(2,1,"Program");
            if (Powersave_PT==3)      draw(setup_str,72,2,1); //lcd.at(2,1,"Shoot (accuracy)");
            if (Powersave_PT==4)      draw(setup_str,73,2,1); //lcd.at(2,1,"Shoot (pwr save)");
            //lcd.at(2,12,"C-Set");            
            first_time=0;
            delay(500);
            NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step
            //delay(prompt_time);
            
          }
        
        if ((millis()-NClastread)>50) {
            NClastread=millis();
            //Serial.print("Read");Serial.println(NClastread);
            NunChuckQuerywithEC();
            NunChuckjoybuttons();
        }

        yUpDown=joy_capture_y1(); 
        
        if (yUpDown==-1) { //  up
            Powersave_PT++;
            if (Powersave_PT>4) {
              Powersave_PT=4;
            }
            else  { 
              first_time=1;
              delay(250);
            }

        } 
        else if (yUpDown==1) { //down
            Powersave_PT--;
            if (Powersave_PT<1) { 
              Powersave_PT=1;
            }
            else  { 
              first_time=1;
              delay(250);
            }
        }
        
        if (Powersave_PT>100) Powersave_PT=2;

        if (c_button) {
        
            //Powersave_PT=prompt_val;
            eeprom_write(98, Powersave_PT);
            progtype=0;
            //delay(500);
            progstep_forward();
        
        }
        
        if (z_button) {
        
            // Powersave_PT=prompt_val;
            eeprom_write(98, Powersave_PT);
            progtype=0;
            progstep_backward();
        }
}


void Setup_Powersave_AUX()   {
     int yUpDown=0;
     
     //int displayvar=0;   
         
         if (first_time==1){
            //prompt_val=Powersave_AUX;
            lcd.empty(); 
            lcd.at(1,1,"AUX Motors On:"); 
            if (Powersave_AUX==1)      draw(setup_str,70,2,1); //lcd.at(2,1,"Always");
            if (Powersave_AUX==2)      draw(setup_str,71,2,1); //lcd.at(2,1,"Program");
            if (Powersave_AUX==3)      draw(setup_str,72,2,1); //lcd.at(2,1,"Shoot (accuracy)");
            if (Powersave_AUX==4)      draw(setup_str,73,2,1); //lcd.at(2,1,"Shoot (pwr save)");
            //lcd.at(2,12,"C-Set");            
            first_time=0;
            delay(500);
            NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step
            //delay(prompt_time);
            
          }
        
        if ((millis()-NClastread)>50) {
            NClastread=millis();
            //Serial.print("Read");Serial.println(NClastread);
            NunChuckQuerywithEC();
            NunChuckjoybuttons();
        }

        yUpDown=joy_capture_y1(); 
        
        if (yUpDown==-1) { //  up
            Powersave_AUX++;
            if (Powersave_AUX>4) {
              Powersave_AUX=4;
            }
            else  { 
              first_time=1;
              delay(250);
            }

        } 
        else if (yUpDown==1) { //down
            Powersave_AUX--;
            if (Powersave_AUX<1) {
              Powersave_AUX=1;
            }
            else  { 
              first_time=1;
              delay(250);
            }
        }
        
        if (Powersave_AUX>100) Powersave_AUX=2;

if (c_button) {
        
            //Powersave_AUX=prompt_val;
            eeprom_write(100, Powersave_AUX);
            progtype=0;
            lcd.empty();
            progstep_forward();

        
        }
        
        if (z_button) {
        
            //Powersave_AUX=prompt_val;
            eeprom_write(100, Powersave_AUX);
            progtype=0;
            //delay(500);
            //progstep_forward();
            progstep_backward();
        }
}



void Setup_LCD_BRIGHTNESS_DURING_RUN()   { //issue with this loop jumping out on first touch of up down - reads ghose C press.
    int yUpDown=0;
     
     
         if (first_time==1){
            lcd.empty();  
            lcd.at(1,1,"BkLite On Run: ");
            lcd.at(1,15,LCD_BRIGHTNESS_DURING_RUN);
            draw(setup_str,65,2,1);//lcd.at(2,1,"UpDown  C-Select");
            first_time=0;
            delay(250);
            NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step
            //delay(prompt_time);
            
          }
        
        if ((millis()-NClastread)>50) {
            NClastread=millis();
            //Serial.print("Read");Serial.println(NClastread);
            NunChuckQuerywithEC();
            NunChuckjoybuttons();
        }

        yUpDown=joy_capture_y1(); 
        
        if (yUpDown==-1) { //  up
              LCD_BRIGHTNESS_DURING_RUN++;
              if (LCD_BRIGHTNESS_DURING_RUN>8) LCD_BRIGHTNESS_DURING_RUN=8;
              lcd.bright(LCD_BRIGHTNESS_DURING_RUN); //this seems to ghost press the C
              c_button=0;
              first_time=1;
              //delay(50);
            }
            
        
        else if (yUpDown==1) { //down
              LCD_BRIGHTNESS_DURING_RUN--;
              if (LCD_BRIGHTNESS_DURING_RUN<1) LCD_BRIGHTNESS_DURING_RUN=1;
              lcd.bright(LCD_BRIGHTNESS_DURING_RUN);
              c_button=0;
              first_time=1;
              //delay(50);
            }
            
   

if (c_button) {
        
            //LCD Values
            eeprom_write(104, LCD_BRIGHTNESS_DURING_RUN);
            progtype=0;
            lcd.empty();
            lcd.at(1,1,"Return Main Menu");
            lcd.bright(6);
            delay(1500);
            NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step
            progstep_goto(0);
        
        }
        
if (z_button) {
        
            //Powersave_AUX=prompt_val;
            eeprom_write(104, LCD_BRIGHTNESS_DURING_RUN);
            progtype=0;
            //delay(500);
            //progstep_forward();
            progstep_backward();
        }
}
